#Veri dosyasının R programına aktarılması
veri <- read.table(file = "veri3.dat", header = TRUE)
View(veri) 
library(metaSEM)

#VERİNİN HAZIRLANMASI
sdeğ <- 4
değad <- c("P","DO","YO", "D")
etiket <- list(değad,değad)
korver <- list()

for (i in 1:nrow(veri)){
  korver[[i]] <- vec2symMat(as.matrix(veri[i,3:8]),diag = FALSE)
  dimnames(korver[[i]]) <- etiket
}

for (i in 1:length(korver)){
  for (j in 1:nrow(korver[[i]])){
    if (sum(is.na(korver[[i]][j,]))==sdeğ-1){
      korver[[i]][j,j] <- NA
    }
  }
  }

for (i in 1:length(korver)){
  for (j in 1:nrow(korver[[i]])){
    for (k in 1:sdeğ){
      if (is.na(korver[[i]][j,k])==TRUE
          &is.na(korver[[i]][j,j])!=TRUE
          &is.na(korver[[i]][k,k])!=TRUE){
        if(sum(is.na(korver[[i]])[j,])>sum(is.na(korver[[i]])[k,])){
          korver[[i]][k,k] = NA}
        if(sum(is.na(korver[[i]])[j,])<=sum(is.na(korver[[i]])[k,])){
          korver[[i]][j,j] = NA}
      }
    }
  }
  }

korver

#sabit etkiler modeli altında korelasyon matrislerinin homojen olup olmadığını incelemesi 
SEM1 <- tssem1(Cov=korver, n=veri$N, method="FEM")
summary(SEM1)

#Rastgele etkiler modeline göre korelasyon matrislerini birleştirilmesi
REM1 <- tssem1(Cov=korver, n=veri$N, method="REM", RE.type="Diag")
summary(REM1)

##A ve S Matrislerinin Hazırlanması
A <- create.mxMatrix(c(0,"0.2*b12","0.2*b13",0,
                       0,0,0,"0.2*b24",
                       0,0,0,"0.2*b34",
                       0,0,0,0),
                     type = "Full",
                     nrow = 4,
                     ncol = 4,
                     byrow = TRUE,
                     name = "A",
                     dimnames = list(değad,değad))

S <- create.mxMatrix(c("0.2*e1",
                       0, "0.2*e2",
                       0,0,"0.2*e3",
                       0, 0, 0, 1),
                     type="Symm", 
                     byrow = TRUE, 
                     name="S",
                     dimnames=list(değad, değad))  

#A ve S simetrik matrisi oluşturulduktan sonra artık modelin uyum iyiliği incelenmesi
REM2 <- tssem2(REM1, Amatrix = A, Smatrix = S, diag.constraints = FALSE)
summary(REM2)

#Yol grafiğinin hazırlanması
library("semPlot")     
grafik <- meta2semPlot(REM2)
semPaths(grafik, whatLabels="est", layout = "tree2")











